' WinDiffWithClipArg.VBS V1.08 (C) yoshioka.teruo@nifty.com 2007-07-27
' WinDiffWithClipArg.VBS runs WinDiff.EXE with arguments in clipboard.
' Usage: WinDiffWithClipArg.VBS [files/folders...]

Option Explicit
'Const Path="""C:\Program Files\Support Tools\WinDiff.EXE"""
Const Path="WinDiff.EXE"
Dim wShell
Dim args
Dim arg
Dim Text
Dim Shell
Dim Folder
Dim FolderItem
Dim Verb
Dim k

args=Array()
For Each arg In WScript.Arguments
  Push args,arg
Next
Set wShell=CreateObject("WScript.Shell")
Text=wShell.Environment("PROCESS").Item(WScript.ScriptName)
If Text="" Then Text=GetCLipByMsForms()
If IsNull(Text) Then Text=GetCLipByMsIE()
Text=Trim(Text)
If Text="" Then
  Set Shell=CreateObject("Shell.Application")
  Set Folder=shell.NameSpace(WScript.ScriptFullName&"\..\")
  Set FolderItem=Folder.Items().Item(WScript.ScriptName)
  For Each Verb In FolderItem.Verbs()
    If Verb.Name="\t(&P)" Then Exit For
  Next
  If IsEmpty(Verb) Then
    args=Join(args,vbCrLf)
    If IsNull(PutClipByMsForms(args)) Then Call PutClipByMsIE(args)
    WScript.Quit
  Else
    wShell.Environment("PROCESS").Item(WScript.ScriptName)=Join(args,vbCrLf)
    Verb.DoIt
    Set Verb=Nothing
    Set FolderItem=Nothing
    Set Folder=Nothing
    Set Shell=Nothing
    WScript.Quit
  End If
Else
  For Each arg In Split(Text,vbCrLf)
    arg=Trim(arg)
    If arg<>"" Then
      Push args,arg
    End If
  Next
  For k=0 To UBound(args)
    If Left(args(k),1)="""" Then
    ElseIf InStr(args(k)," ") Then
      args(k)="""" & args(k) & """"
    End If
  Next
  args=Path&" "&Join(args)
'  If vbCancel=MsgBox("'" & args & "'",vbOkCancel+vbQuestion,"N܂ ?") Then WScript.Quit
  wShell.Run args
  WScript.Quit
End If

Function GetCLipByMsIE()
Const OLECMDID_PASTE = 13
Const OLECMDEXECOPT_DODEFAULT = 0
Dim ie
Set ie=CreateObject("InternetExplorer.Application")
'ie.Visible=true
ie.Navigate "about:blank"
Do While ie.Busy Or ie.ReadyState<>4
  WScript.Sleep 100
Loop
ie.Document.write "<html><body><textarea id=txt></textarea></body></html>"
ie.Document.all.txt.focus
Call ie.ExecWB(OLECMDID_PASTE,OLECMDEXECOPT_DODEFAULT)
GetCLipByMsIE=ie.Document.all.txt.value
ie.Quit 
End Function

Function GetCLipByMsForms()
Dim uf
Dim tb
Dim Text
On Error Resume Next
Set uf=CreateObject("Forms.Form.1")
On Error GoTo 0
If IsEmpty(uf) Then
  GetCLipByMsForms=Null
  Exit Function
End If
Set tb=uf.Controls.Add("Forms.TextBox.1").Object
tb.MultiLine=True
If tb.CanPaste Then
  tb.Paste
End If
Text=tb.Text
Set tb=Nothing
Set uf=Nothing
GetCLipByMsForms=Text
End Function

Sub Push(Items,Item)
ReDim Preserve Items(UBound(Items)+1)
Items(UBound(Items))=Item
End Sub

Function PutClipByMsIE(args)
Const OLECMDID_COPY = 12
Const OLECMDID_SELECTALL = 17 '(&H11)
Const OLECMDEXECOPT_DODEFAULT = 0
Dim ie
Set ie=CreateObject("InternetExplorer.Application")
'ie.Visible=true
ie.Navigate "about:blank"
Do While ie.Busy Or ie.ReadyState<>4
  WScript.Sleep 100
Loop
ie.Document.body.innerText=args
ie.ExecWB OLECMDID_SELECTALL,OLECMDEXECOPT_DODEFAULT
ie.ExecWB OLECMDID_COPY,OLECMDEXECOPT_DODEFAULT
ie.Quit 
Set ie=Nothing
End Function

Function PutClipByMsForms(args)
Dim uf
Dim tb
On Error Resume Next
Set uf=CreateObject("Forms.Form.1")
On Error GoTo 0
If IsEmpty(uf) Then
  PutClipByMsForms=Null
  Exit Function
End If
Set tb=uf.Controls.Add("Forms.TextBox.1").Object
tb.MultiLine=True
tb.Text=args
tb.SelStart=0
tb.SelLength=tb.TextLength
tb.Copy
Set tb=Nothing
Set uf=Nothing
End Function
